<template>
  <div>
    <div
      class="text-subtitle1 tamano-letra-titulos-modulos letras-system style-title-list-left"
    >
      Dashboard
    </div>

    <div class="row">
      <div class="q-mr-md q-mt-md margin-fields-form">
        <div class="text-subtitle1 tamano-letra-titulos-modulos letras-system">
          Filtrar por Fecha
        </div>
      </div>
    </div>

    <template v-if="loading_range_date_card">
      <SqeletonRangeDateCard />
    </template>
    <template v-else>
      <div class="row q-mt-sm">
        <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
          <VueCtkDateTimePicker
            id="rango-de-fechas"
            v-model="range_date_card"
            :label="'Seleccionar rango de fechas'"
            output-format="DD-MM-YYYY"
            :range="true"
            only-date
            color="red"
            locale="es"
            :custom-shortcuts="customShortcuts"
            no-label
            @input="updateRangeDateFilterCard"
          />
        </div>
      </div>
    </template>

    <template v-if="loading_data_card">
      <SqeletonCard />
    </template>
    <template v-else>
      <div class="row">
        <div class="col-xs-12 col-sm-6 col-md-6 col-lg-3">
          <Card
            :class-bg="'bg-red-2'"
            :value="data_card.average"
            :value-text="'Promedio de Edades'"
            :class-text="'text-red-5'"
            :icon="'mdi-calendar'"
          />
        </div>

        <div class="col-xs-12 col-sm-6 col-md-6 col-lg-3">
          <Card
            :class-bg="'bg-amber-2'"
            :value="data_card.standard_deviation"
            :value-text="'Desviación Estandar'"
            :class-text="'text-amber-7'"
            :icon="'mdi-chart-bell-curve'"
          />
        </div>

        <div class="col-xs-12 col-sm-6 col-md-6 col-lg-3">
          <Card
            :class-bg="'bg-green-2'"
            :value="data_card.total_customers"
            :value-text="'Total de Clientes'"
            :class-text="'text-green-7'"
            :icon="'mdi-account-multiple'"
          />
        </div>

        <div class="col-xs-12 col-sm-6 col-md-6 col-lg-3">
          <Card
            :class-bg="'bg-cyan-2'"
            :value="data_card.max_age"
            :value-text="'Edad máxima'"
            :class-text="'text-cyan-6'"
            :icon="'mdi-calendar-check'"
          />
        </div>
      </div>
    </template>

    <div class="row q-mt-md">
      <div class="q-mr-md q-mt-md margin-fields-form">
        <div class="text-subtitle1 tamano-letra-titulos-modulos letras-system">
          Filtrar por Fecha
        </div>
      </div>
    </div>

    <template v-if="loading_range_date_pies">
      <SqeletonRangeDateCard />
    </template>
    <template v-else>
      <div class="row q-mt-sm">
        <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
          <VueCtkDateTimePicker
            id="rango-de-fechas-pies"
            v-model="range_date_pies"
            :label="'Seleccionar rango de fechas'"
            output-format="DD-MM-YYYY"
            :range="true"
            only-date
            color="red"
            locale="es"
            :custom-shortcuts="customShortcuts"
            no-label
            @input="updateRangeDateFilterPies"
          />
        </div>
      </div>
    </template>

    <div v-if="loading_pies">
      <div class="row">
        <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12" v-for="j in 2">
          <SqeletonPies />
        </div>
      </div>
    </div>
    <div v-else>
      <div class="row">
        <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
          <ApexChartPie
            :text="'Cantidad de clientes de acuerdo al género'"
            :chartOptions="data_pies_1_chart_options"
            :series="data_pies_1_series"
          />
        </div>

        <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
          <ApexChartPie
            :text="'Edades con mayor cantidad de clientes'"
            :chartOptions="data_pies_2_chart_options"
            :series="data_pies_2_series"
          />
        </div>
      </div>
    </div>

    <div class="row q-mt-lg">
      <div class="q-mr-md q-mt-md margin-fields-form">
        <div class="text-subtitle1 tamano-letra-titulos-modulos letras-system">
          Filtro de los últimos 7 días
        </div>
      </div>
    </div>

    <div v-if="loading_column1">
      <div class="row">
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
          <SqeletonColumn />
        </div>
      </div>
    </div>
    <div v-else>
      <div class="row">
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
          <ApexChartColumn
            :text="'Clientes registrados por día de acuerdo al género'"
            :chartOptions="data_column_1_chart_options"
            :series="data_column_1_series"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import SqeletonCard from "../../../components/sqleton/Dashboard/LoadingCards";
import SqeletonPies from "../../../components/sqleton/Dashboard/LoadingPies";
import SqeletonColumn from "../../../components/sqleton/Dashboard/LoadingColumn";
import SqeletonRangeDateCard from "../../../components/sqleton/Dashboard/LoadingRangeDateCard";
import Card from "../../../components/dashboard/Card";
import ApexChartPie from "../../../components/dashboard/ApexChartPie";
import ApexChartColumn from "../../../components/dashboard/ApexChartColumn";

export default {
  components: {
    SqeletonCard,
    SqeletonPies,
    SqeletonColumn,
    SqeletonRangeDateCard,
    Card,
    ApexChartPie,
    ApexChartColumn,
  },
  data() {
    return {
      //Echo
      apiUrl: process.env.BASE_URL_API,

      //dates
      range_date_card: "",
      range_date_pies: "",
      range_date_column: "",
      customShortcuts: [
        { key: "thisWeek", label: "Esta semana", value: "isoWeek" },
        { key: "lastWeek", label: "Última semana", value: "-isoWeek" },
        { key: "last7Days", label: "Últimos 7 días", value: 7 },
        { key: "last30Days", label: "Últimos 30 días", value: 30 },
        { key: "thisMonth", label: "Este mes", value: "month" },
        { key: "lastMonth", label: "Último mes", value: "-month" },
        { key: "thisYear", label: "Este año", value: "year" },
        { key: "lastYear", label: "Último año", value: "-year" },
      ],

      //loadings
      loading_data_card: false,
      loading_range_date_card: false,
      loading_pies: true,
      loading_range_date_pies: false,
      loading_range_date_column: false,
      loading_column1: true,

      //datas
      data_card: [],
      data_pies_1_chart_options: {
        labels: [],
        chart: {
          type: "pie",
        },
        legend: {
          position: "bottom",
        },
        responsive: [
          {
            breakpoint: 600,
            options: {
              chart: {
                width: 200,
                height: 300,
              },
              legend: {
                position: "bottom",
              },
            },
          },
        ],
      },
      data_pies_1_series: [],

      data_pies_2_chart_options: {
        labels: [],
        chart: {
          type: "pie",
        },
        legend: {
          position: "bottom",
        },
        responsive: [
          {
            breakpoint: 600,
            options: {
              chart: {
                width: 200,
                height: 300,
              },
              legend: {
                position: "bottom",
              },
            },
          },
        ],
      },
      data_pies_2_series: [],

      data_column_1_series: [],

      data_column_1_chart_options: {
        chart: {
          type: "bar",
          height: 350,
        },
        plotOptions: {
          bar: {
            horizontal: false,
            columnWidth: "55%",
            endingShape: "rounded",
          },
        },
        dataLabels: {
          enabled: false,
        },
        stroke: {
          show: true,
          width: 2,
          colors: ["transparent"],
        },
        xaxis: {
          categories: [],
        },
        yaxis: {
          title: {
            text: "Registros",
          },
        },
        fill: {
          opacity: 1,
        },
        tooltip: {
          y: {
            formatter: function (val) {
              return +val + " Registros";
            },
          },
        },
      },
    };
  },

  methods: {
    getElement() {
      this.loading_range_date_card = true;
      this.loading_range_date_pies = true;
      this.loading_range_date_column = true;
      this.loading_data_card = true;
      this.loading_pies = true;
      this.loading_column1 = true;
      this.$axios.get("api/auth/v1/dashboard").then((response) => {
        this.data_card = response.data.data.data_card;

        //datas
        this.data_pies_1_series = response.data.data.data_pies_1.series;
        this.data_pies_2_series = response.data.data.data_pies_2.series;

        this.data_column_1_series = response.data.data.data_column_1.series;

        this.data_pies_1_chart_options.labels =
          response.data.data.data_pies_1.labels;
        this.data_pies_2_chart_options.labels =
          response.data.data.data_pies_2.labels;

        this.data_column_1_chart_options.xaxis.categories =
          response.data.data.data_column_1.array_days_back;

        //dates
        this.range_date_card = response.data.data.data_range;
        this.range_date_pies = response.data.data.data_range;
        this.range_date_column = response.data.data.data_range;

        //loadings
        this.loading_range_date_card = false;
        this.loading_range_date_pies = false;
        this.loading_range_date_column = false;
        this.loading_data_card = false;
        this.loading_pies = false;
        this.loading_column1 = false;
      });
    },
    updateRangeDateFilterCard(event) {
      if (event && event.end && event.start) {
        this.loading_data_card = true;
        this.$axios
          .post("api/auth/v1/dashboard/get-data-filter-cards", event)
          .then((response) => {
            this.loading_data_card = false;
            this.data_card = response.data.data.data_card;
          });
      }
    },
    updateRangeDateFilterPies(event) {
      if (event && event.end && event.start) {
        this.loading_pies = true;
        this.$axios
          .post("api/auth/v1/dashboard/get-data-filter-pies", event)
          .then((response) => {
            this.data_pies_1_series = response.data.data.data_pies_1.series;
            this.data_pies_2_series = response.data.data.data_pies_2.series;

            this.data_pies_1_chart_options.labels =
              response.data.data.data_pies_1.labels;
            this.data_pies_2_chart_options.labels =
              response.data.data.data_pies_2.labels;

            this.loading_pies = false;
          });
      }
    },
  },

  created() {
    this.getElement();
  },
};
</script>

<style scoped>
/*esto para mejorar el diseño del date picker */
/deep/ .flex {
  flex-wrap: initial;
}
</style>